Loading...
Searching...
No Matches
irr::scene::IDynamicMeshBuffer Class Referenceabstract

`#include <IDynamicMeshBuffer.h>`

Inheritance diagram for irr::scene::IDynamicMeshBuffer:

## Public Member Functions

virtual void | append (const IMeshBuffer *const other)
| Append the meshbuffer to the current buffer.
virtual void | append (const void *const vertices, u32 numVertices, const u16 *const indices, u32 numIndices)
| Append the vertices and indices to the current buffer.
virtual const core::aabbox3df & | getBoundingBox () const =0
| Get the axis aligned bounding box of this meshbuffer.
virtual u32 | getChangedID_Index () const
| Get the currently used ID for identification of changes.
virtual u32 | getChangedID_Vertex () const
| Get the currently used ID for identification of changes.
virtual E_HARDWARE_MAPPING | getHardwareMappingHint_Index () const
| get the current hardware mapping hint
virtual E_HARDWARE_MAPPING | getHardwareMappingHint_Vertex () const
| get the current hardware mapping hint
virtual IIndexBuffer & | getIndexBuffer () const =0
virtual u32 | getIndexCount () const
| Get amount of indices in this meshbuffer.
virtual video::E_INDEX_TYPE | getIndexType () const
| Get type of index data which is stored in this meshbuffer.
virtual u16 * | getIndices ()
| Get access to Indices.
virtual const u16 * | getIndices () const
| Get access to Indices.
virtual const video::SMaterial & | getMaterial () const =0
| Get the material of this meshbuffer.
virtual video::SMaterial & | getMaterial ()=0
| Get the material of this meshbuffer.
virtual core::vector3df & | getNormal (u32 i)
| returns normal of vertex i
virtual const core::vector3df & | getNormal (u32 i) const
| returns normal of vertex i
virtual core::vector3df & | getPosition (u32 i)
| returns position of vertex i
virtual const core::vector3df & | getPosition (u32 i) const
| returns position of vertex i
virtual core::vector2df & | getTCoords (u32 i)
| returns texture coords of vertex i
virtual const core::vector2df & | getTCoords (u32 i) const
| returns texture coords of vertex i
virtual IVertexBuffer & | getVertexBuffer () const =0
virtual u32 | getVertexCount () const
| Get amount of vertices in meshbuffer.
virtual video::E_VERTEX_TYPE | getVertexType () const
| Get type of vertex data which is stored in this meshbuffer.
virtual void * | getVertices ()
| Get access to vertex data. The data is an array of vertices.
virtual const void * | getVertices () const
| Get access to vertex data. The data is an array of vertices.
virtual void | recalculateBoundingBox ()=0
| Recalculates the bounding box. Should be called if the mesh changed.
virtual void | setBoundingBox (const core::aabbox3df &box)=0
| Set axis aligned bounding box.
virtual void | setDirty (E_BUFFER_TYPE Buffer=EBT_VERTEX_AND_INDEX)
| flags the mesh as changed, reloads hardware buffers
virtual void | setHardwareMappingHint (E_HARDWARE_MAPPING NewMappingHint, E_BUFFER_TYPE Buffer=EBT_VERTEX_AND_INDEX)
| set the hardware mapping hint, for driver
virtual void | setIndexBuffer (IIndexBuffer *indexBuffer)=0
virtual void | setVertexBuffer (IVertexBuffer *vertexBuffer)=0
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Additional Inherited Members

Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Detailed Description

a dynamic meshBuffer

Definition at line 18 of file IDynamicMeshBuffer.h.

## Member Function Documentation

## append() [1/2]

virtual void irr::scene::IDynamicMeshBuffer::append | ( | const IMeshBuffer *const | other | ) |

inline virtual

Append the meshbuffer to the current buffer.

Only works for compatible vertex types

Parameters

  other | Buffer to append to this one.

Implements irr::scene::IMeshBuffer.

Definition at line 61 of file IDynamicMeshBuffer.h.

## append() [2/2]

virtual void irr::scene::IDynamicMeshBuffer::append | ( | const void *const | vertices,
|  | u32 | numVertices,
|  | const u16 *const | indices,
|  | u32 | numIndices )

inline virtual

Append the vertices and indices to the current buffer.

Only works for compatible vertex types.

Parameters

  vertices | Pointer to a vertex array.
  numVertices | Number of vertices in the array.
  indices | Pointer to index array.
  numIndices | Number of indices in array.

Implements irr::scene::IMeshBuffer.

Definition at line 53 of file IDynamicMeshBuffer.h.

## getBoundingBox()

virtual const core::aabbox3df & irr::scene::IDynamicMeshBuffer::getBoundingBox | ( |  | ) | const

pure virtual

Get the axis aligned bounding box of this meshbuffer.

Returns
  Axis aligned bounding box of this buffer.

Implements irr::scene::IMeshBuffer.

Implemented in irr::scene::CDynamicMeshBuffer.

## getChangedID_Index()

virtual u32 irr::scene::IDynamicMeshBuffer::getChangedID_Index | ( |  | ) | const

inline virtual

Get the currently used ID for identification of changes.

This shouldn't be used for anything outside the VideoDriver.

Implements irr::scene::IMeshBuffer.

Definition at line 103 of file IDynamicMeshBuffer.h.

References irr::scene::IIndexBuffer::getChangedID(), and getIndexBuffer().

## getChangedID_Vertex()

virtual u32 irr::scene::IDynamicMeshBuffer::getChangedID_Vertex | ( |  | ) | const

inline virtual

Get the currently used ID for identification of changes.

This shouldn't be used for anything outside the VideoDriver.

Implements irr::scene::IMeshBuffer.

Definition at line 98 of file IDynamicMeshBuffer.h.

References irr::scene::IVertexBuffer::getChangedID(), and getVertexBuffer().

## getHardwareMappingHint_Index()

virtual E_HARDWARE_MAPPING irr::scene::IDynamicMeshBuffer::getHardwareMappingHint_Index | ( |  | ) | const

inline virtual

get the current hardware mapping hint

Implements irr::scene::IMeshBuffer.

Definition at line 75 of file IDynamicMeshBuffer.h.

References irr::scene::IIndexBuffer::getHardwareMappingHint(), and getIndexBuffer().

## getHardwareMappingHint_Vertex()

virtual E_HARDWARE_MAPPING irr::scene::IDynamicMeshBuffer::getHardwareMappingHint_Vertex | ( |  | ) | const

inline virtual

get the current hardware mapping hint

Implements irr::scene::IMeshBuffer.

Definition at line 69 of file IDynamicMeshBuffer.h.

References irr::scene::IVertexBuffer::getHardwareMappingHint(), and getVertexBuffer().

## getIndexBuffer()

virtual IIndexBuffer & irr::scene::IDynamicMeshBuffer::getIndexBuffer | ( |  | ) | const

pure virtual

Implemented in irr::scene::CDynamicMeshBuffer.

Referenced by getChangedID_Index(), getHardwareMappingHint_Index(), getIndexCount(), getIndexType(), getIndices(), getIndices(), setDirty(), and setHardwareMappingHint().

## getIndexCount()

virtual u32 irr::scene::IDynamicMeshBuffer::getIndexCount | ( |  | ) | const

inline virtual

Get amount of indices in this meshbuffer.

Returns
  Number of indices in this buffer.

Implements irr::scene::IMeshBuffer.

Definition at line 163 of file IDynamicMeshBuffer.h.

References getIndexBuffer(), and irr::scene::IIndexBuffer::size().

## getIndexType()

virtual video::E_INDEX_TYPE irr::scene::IDynamicMeshBuffer::getIndexType | ( |  | ) | const

inline virtual

Get type of index data which is stored in this meshbuffer.

Returns
  Index type of this buffer.

Implements irr::scene::IMeshBuffer.

Definition at line 142 of file IDynamicMeshBuffer.h.

References getIndexBuffer(), and irr::scene::IIndexBuffer::getType().

## getIndices() [1/2]

virtual u16 * irr::scene::IDynamicMeshBuffer::getIndices | ( |  | ) |

inline virtual

Get access to Indices.

Returns
  Pointer to indices array.

Implements irr::scene::IMeshBuffer.

Definition at line 156 of file IDynamicMeshBuffer.h.

References irr::scene::IIndexBuffer::getData(), and getIndexBuffer().

## getIndices() [2/2]

virtual const u16 * irr::scene::IDynamicMeshBuffer::getIndices | ( |  | ) | const

inline virtual

Get access to Indices.

Returns
  Pointer to indices array.

Implements irr::scene::IMeshBuffer.

Definition at line 149 of file IDynamicMeshBuffer.h.

References irr::scene::IIndexBuffer::getData(), and getIndexBuffer().

## getMaterial() [1/2]

virtual const video::SMaterial & irr::scene::IDynamicMeshBuffer::getMaterial | ( |  | ) | const

pure virtual

Get the material of this meshbuffer.

Returns
  Material of this buffer.

Implements irr::scene::IMeshBuffer.

Implemented in irr::scene::CDynamicMeshBuffer.

## getMaterial() [2/2]

virtual video::SMaterial & irr::scene::IDynamicMeshBuffer::getMaterial | ( |  | ) |

pure virtual

Get the material of this meshbuffer.

Returns
  Material of this buffer.

Implements irr::scene::IMeshBuffer.

Implemented in irr::scene::CDynamicMeshBuffer.

## getNormal() [1/2]

virtual core::vector3df & irr::scene::IDynamicMeshBuffer::getNormal | ( | u32 | i | ) |

inline virtual

returns normal of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 199 of file IDynamicMeshBuffer.h.

References getVertexBuffer().

## getNormal() [2/2]

virtual const core::vector3df & irr::scene::IDynamicMeshBuffer::getNormal | ( | u32 | i | ) | const

inline virtual

returns normal of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 193 of file IDynamicMeshBuffer.h.

References getVertexBuffer().

## getPosition() [1/2]

virtual core::vector3df & irr::scene::IDynamicMeshBuffer::getPosition | ( | u32 | i | ) |

inline virtual

returns position of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 175 of file IDynamicMeshBuffer.h.

References getVertexBuffer().

## getPosition() [2/2]

virtual const core::vector3df & irr::scene::IDynamicMeshBuffer::getPosition | ( | u32 | i | ) | const

inline virtual

returns position of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 169 of file IDynamicMeshBuffer.h.

References getVertexBuffer().

## getTCoords() [1/2]

virtual core::vector2df & irr::scene::IDynamicMeshBuffer::getTCoords | ( | u32 | i | ) |

inline virtual

returns texture coords of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 187 of file IDynamicMeshBuffer.h.

References getVertexBuffer().

## getTCoords() [2/2]

virtual const core::vector2df & irr::scene::IDynamicMeshBuffer::getTCoords | ( | u32 | i | ) | const

inline virtual

returns texture coords of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 181 of file IDynamicMeshBuffer.h.

References getVertexBuffer().

## getVertexBuffer()

virtual IVertexBuffer & irr::scene::IDynamicMeshBuffer::getVertexBuffer | ( |  | ) | const

pure virtual

Implemented in irr::scene::CDynamicMeshBuffer.

Referenced by getChangedID_Vertex(), getHardwareMappingHint_Vertex(), getNormal(), getNormal(), getPosition(), getPosition(), getTCoords(), getTCoords(), getVertexCount(), getVertexType(), getVertices(), getVertices(), setDirty(), and setHardwareMappingHint().

## getVertexCount()

virtual u32 irr::scene::IDynamicMeshBuffer::getVertexCount | ( |  | ) | const

inline virtual

Get amount of vertices in meshbuffer.

Returns
  Number of vertices in this buffer.

Implements irr::scene::IMeshBuffer.

Definition at line 135 of file IDynamicMeshBuffer.h.

References getVertexBuffer(), and irr::scene::IVertexBuffer::size().

## getVertexType()

virtual video::E_VERTEX_TYPE irr::scene::IDynamicMeshBuffer::getVertexType | ( |  | ) | const

inline virtual

Get type of vertex data which is stored in this meshbuffer.

Returns
  Vertex type of this buffer.

Implements irr::scene::IMeshBuffer.

Definition at line 112 of file IDynamicMeshBuffer.h.

References irr::scene::IVertexBuffer::getType(), and getVertexBuffer().

## getVertices() [1/2]

virtual void * irr::scene::IDynamicMeshBuffer::getVertices | ( |  | ) |

inline virtual

Get access to vertex data. The data is an array of vertices.

Which vertex type is used can be determined by getVertexType().

Returns
  Pointer to array of vertices.

Implements irr::scene::IMeshBuffer.

Definition at line 128 of file IDynamicMeshBuffer.h.

References irr::scene::IVertexBuffer::getData(), and getVertexBuffer().

## getVertices() [2/2]

virtual const void * irr::scene::IDynamicMeshBuffer::getVertices | ( |  | ) | const

inline virtual

Get access to vertex data. The data is an array of vertices.

Which vertex type is used can be determined by getVertexType().

Returns
  Pointer to array of vertices.

Implements irr::scene::IMeshBuffer.

Definition at line 120 of file IDynamicMeshBuffer.h.

References irr::scene::IVertexBuffer::getData(), and getVertexBuffer().

## recalculateBoundingBox()

virtual void irr::scene::IDynamicMeshBuffer::recalculateBoundingBox | ( |  | ) |

pure virtual

Recalculates the bounding box. Should be called if the mesh changed.

Implements irr::scene::IMeshBuffer.

Implemented in irr::scene::CDynamicMeshBuffer.

## setBoundingBox()

virtual void irr::scene::IDynamicMeshBuffer::setBoundingBox | ( | const core::aabbox3df & | box | ) |

pure virtual

Set axis aligned bounding box.

Parameters

  box | User defined axis aligned bounding box to use for this buffer.

Implements irr::scene::IMeshBuffer.

Implemented in irr::scene::CDynamicMeshBuffer.

## setDirty()

virtual void irr::scene::IDynamicMeshBuffer::setDirty | ( | E_BUFFER_TYPE | Buffer = EBT_VERTEX_AND_INDEX | ) |

inline virtual

flags the mesh as changed, reloads hardware buffers

Implements irr::scene::IMeshBuffer.

Definition at line 90 of file IDynamicMeshBuffer.h.

References irr::scene::EBT_INDEX, irr::scene::EBT_VERTEX, irr::scene::EBT_VERTEX_AND_INDEX, getIndexBuffer(), getVertexBuffer(), irr::scene::IIndexBuffer::setDirty(), and irr::scene::IVertexBuffer::setDirty().

## setHardwareMappingHint()

virtual void irr::scene::IDynamicMeshBuffer::setHardwareMappingHint | ( | E_HARDWARE_MAPPING | NewMappingHint,
|  | E_BUFFER_TYPE | Buffer = EBT_VERTEX_AND_INDEX )

inline virtual

set the hardware mapping hint, for driver

Implements irr::scene::IMeshBuffer.

Definition at line 81 of file IDynamicMeshBuffer.h.

References irr::scene::EBT_INDEX, irr::scene::EBT_VERTEX, irr::scene::EBT_VERTEX_AND_INDEX, getIndexBuffer(), getVertexBuffer(), irr::scene::IIndexBuffer::setHardwareMappingHint(), and irr::scene::IVertexBuffer::setHardwareMappingHint().

## setIndexBuffer()

virtual void irr::scene::IDynamicMeshBuffer::setIndexBuffer | ( | IIndexBuffer * | indexBuffer | ) |

pure virtual

Implemented in irr::scene::CDynamicMeshBuffer.

## setVertexBuffer()

virtual void irr::scene::IDynamicMeshBuffer::setVertexBuffer | ( | IVertexBuffer * | vertexBuffer | ) |

pure virtual

Implemented in irr::scene::CDynamicMeshBuffer.

The documentation for this class was generated from the following file:

- IDynamicMeshBuffer.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0